from frostfs_testlib.shell import CommandOptions
from frostfs_testlib.storage.cluster import ClusterNode


class IpHelper:
    @staticmethod
    def drop_input_traffic_to_node(node: ClusterNode, block_ip: list[tuple]) -> None:
        shell = node.host.get_shell()
        for ip, table in block_ip:
            if not table:
                shell.exec(f"ip r a blackhole {ip}")
                continue
            shell.exec(f"ip r a blackhole {ip} table {table}")

    @staticmethod
    def restore_input_traffic_to_node(node: ClusterNode) -> None:
        shell = node.host.get_shell()
        unlock_ip = shell.exec("ip r l table all | grep blackhole", CommandOptions(check=False)).stdout

        for active_blackhole in unlock_ip.strip().split("\n"):
            shell.exec(f"ip r d {active_blackhole}")
